AWSTemplateFormatVersion: "2010-09-09"
Description: "Backend Orchestration for the Saving Nature Batch Processing Job "

Parameters:
    BucketPrefix: 
        Type: "String"
        Default: "saving-nature-uploads-test"
    StackName:
        Type: "String"
        Default: "Batch-Proc-Backend"
    DropboxAppKey:
        Type: "String"
        Default: "7tr3276zwa55c08"
    DropboxAppSecret:
        Type: "String"
        Default: "5qjuvoyyrck1ds4"
    DropboxRefreshToken:
        Type: "String"
        Default: "riBTtNqltdkAAAAAAAAAARpL7WHrMwrh1IXNuPDhG7I2VWfXyXuEwbZ1n3VB32BH"
    DropboxRefreshURL:
        Type: "String"
        Default: "https://api.dropbox.com/oauth2/token"
    DynamoDBTableName:
        Type: "String"
        Default: "prediction_results_and_metadata"
    BatchJobQueueName:
        Type: "String"
        Default: "saving-nature-batch"
    BatchJobDefinitionName:
        Type: "String"
        Default: "video-prediction"
    BatchComputeEnvName:
        Type: "String"
        Default: "saving-nature-fargate-batch"
    BatchPredictionECRRepoName:
        Type: "String"
        Default: "batch-prediction"
    getPresignedURLFunctionName:
        Type: "String"
        Default: "getPresignedURL"
    exportDynamoDBFunctionName:
        Type: "String"
        Default: "exportDynamoDB"
    triggerBatchFunctionName:
        Type: "String"
        Default: "triggerBatch"

Resources:
    
    ####
    # VPC & Subnet Config and Connections
    ####
    
    VPC:
        Type: AWS::EC2::VPC
        Properties:
          CidrBlock: 10.0.0.0/16
          EnableDnsSupport: true
          EnableDnsHostnames: true
    
    InternetGateway:
        Type: AWS::EC2::InternetGateway
    
    PublicSubnetRouteTable:
        Type: AWS::EC2::RouteTable
        Properties:
          VpcId: !Ref VPC
    
    VPCGatewayAttachment:
        Type: AWS::EC2::VPCGatewayAttachment
        Properties:
          VpcId: !Ref VPC
          InternetGatewayId: !Ref InternetGateway
    
    NATEIP:
        DependsOn: VPCGatewayAttachment
        Type: AWS::EC2::EIP
        Properties:
          Domain: vpc        
    
    NATGateway:
        DependsOn: VPCGatewayAttachment
        Type: AWS::EC2::NatGateway
        Properties:
            AllocationId:
              Fn::GetAtt:
                - NATEIP
                - AllocationId
            SubnetId: !Ref PublicSubnet    
    
    SecurityGroup:
        Type: AWS::EC2::SecurityGroup
        Properties:
          GroupDescription: EC2 Security Group for instances launched in the VPC by Batch
          VpcId: !Ref VPC
    
    PublicSubnet:
        Type: AWS::EC2::Subnet
        Properties:
          CidrBlock: 10.0.0.0/24
          VpcId: !Ref VPC
          MapPublicIpOnLaunch: 'True'
          Tags:
            - Key: Name
              Value: !Sub ${StackName} Public Subnet  
    
    PrivateSubnet:
        Type: AWS::EC2::Subnet
        Properties:
          CidrBlock: 10.0.1.0/24
          VpcId: !Ref VPC
          Tags:
            - Key: Name
              Value: !Sub ${StackName} Private Subnet   
    
    PublicSubnetRouteTable:
        Type: AWS::EC2::RouteTable
        Properties:
          VpcId: !Ref VPC
          Tags:
            - Key: Name
              Value: !Sub ${StackName} Public Route        
            - Key: Project
              Value: AWS Batch in Fargate         
    
    PublicSubnetRoute:
        Type: AWS::EC2::Route
        DependsOn: VPCGatewayAttachment
        Properties:
          RouteTableId: !Ref PublicSubnetRouteTable
          DestinationCidrBlock: 0.0.0.0/0
          GatewayId: !Ref InternetGateway
    
    PublicSubnetRouteTableAssociation:
        Type: AWS::EC2::SubnetRouteTableAssociation
        Properties:
          SubnetId: !Ref PublicSubnet
          RouteTableId: !Ref PublicSubnetRouteTable
    
    PrivateSubnetRouteTable:
          Type: AWS::EC2::RouteTable
          Properties:
            VpcId: !Ref VPC
            Tags:
              - Key: Name
                Value: !Sub ${StackName} Private Route    
              - Key: Project
                Value: AWS Batch in Fargate                         
    
    PrivateSubnetRoute:
        Type: AWS::EC2::Route
        Properties:
          RouteTableId: !Ref 'PrivateSubnetRouteTable'
          DestinationCidrBlock: 0.0.0.0/0
          NatGatewayId: !Ref NATGateway
    
    PrivateSubnetRouteTableAssociation:
        Type: AWS::EC2::SubnetRouteTableAssociation
        Properties:
          SubnetId: !Ref PrivateSubnet
          RouteTableId: !Ref PrivateSubnetRouteTable   
        
    ####    
    # Batch Job Resources and Roles
    ####
    
    S3Bucket:
        Type: "AWS::S3::Bucket"
        DependsOn: InvokeLambdaPermission
        Properties:
            BucketName: !Sub "${BucketPrefix}"
            NotificationConfiguration: 
                LambdaConfigurations: 
                  - Event: "s3:ObjectCreated:*"
                    Filter: 
                        S3Key: 
                            Rules: 
                              - 
                                Name: "Suffix"
                                Value: ".mp4"
                    Function: !Sub "arn:aws:lambda:${AWS::Region}:${AWS::AccountId}:function:${triggerBatchFunctionName}"
    
    InvokeLambdaPermission:
        DependsOn: TriggerBatchFunction
        Type: "AWS::Lambda::Permission"
        Properties:
            Action: "lambda:InvokeFunction"
            FunctionName: !GetAtt TriggerBatchFunction.Arn
            Principal: "s3.amazonaws.com"
            SourceArn: !Sub "arn:aws:s3:::${BucketPrefix}"     
          
    TriggerBatchFunction:
        Type: "AWS::Lambda::Function"
        Properties:
            Description: ""
            FunctionName: !Sub "${triggerBatchFunctionName}"
            Handler: "index.lambda_handler"
            Architectures: 
              - "x86_64"
            Code: 
                ZipFile: !Sub |
                    import boto3
                    import json
                    def get_batch_parameters():
                        batch_parameters = {
                            "jobName":"video-prediction",
                            "jobQueue":${BatchJobQueueName},
                            "jobDefinition":${BatchJobDefinitionName},
                            "parameters":{
                                "s3videoName": None,
                                "logLevel": '20',
                                "predThresh": ".5"
                            }
                        }
                        return batch_parameters
                    
                
                    def update_videoName_parameter(s3videoName, params):
                        params['parameters']['s3videoName'] = s3videoName
                        return params
                        
                    client = boto3.client('batch')
                    
                    def submit_batch_job(parameters):
                        response = client.submit_job(
                            jobName=parameters['jobName'],
                            jobQueue=parameters['jobQueue'],
                            jobDefinition=parameters['jobDefinition'],
                            parameters=parameters['parameters'])
                        return response
                    
                    
                    def lambda_handler(event, context):
                        print(f"Lambda event triggered by S3. {event}, {context}")
                        s3videoName = event['Records'][0]['s3']['object']['key'].split('/')[-1]
                        s3videoName = s3videoName.replace("+", " ")
                        params = get_batch_parameters()
                        params = update_videoName_parameter(s3videoName,params)
                        print(f"Submitting job with parameters {params}")
                        response = submit_batch_job(params)
                        
                        return {
                            'statusCode': 200,
                            'body': json.dumps(response)
                        }
            MemorySize: 128
            Role: !GetAtt TriggerBatchFunctionRole.Arn
            Runtime: "python3.9"
            Timeout: 3
            TracingConfig: 
                Mode: "PassThrough"

    BatchPredictionECRRepository:
        DependsOn: BatchComputeEnvironment
        Type: "AWS::ECR::Repository"
        Properties:
            RepositoryName: !Sub "${BatchPredictionECRRepoName}" 

    BatchComputeEnvironment:
        Type: "AWS::Batch::ComputeEnvironment"
        Properties:
            ComputeEnvironmentName: !Sub "${BatchComputeEnvName}"
            Type: "MANAGED"
            ServiceRole: !Sub "arn:aws:iam::${AWS::AccountId}:role/aws-service-role/batch.amazonaws.com/AWSServiceRoleForBatch"
            ComputeResources: 
                Type: "FARGATE_SPOT"
                MaxvCpus: 256
                Subnets: 
                  - !Ref PrivateSubnet
                SecurityGroupIds: 
                  - !Ref SecurityGroup
                Tags: {}

    BatchJobDefinition:
        Type: "AWS::Batch::JobDefinition"
        Properties:
            JobDefinitionName: !Sub "${BatchJobDefinitionName}"
            Type: "container"
            Parameters: 
                s3videoName: "10120045.mp4"
            RetryStrategy: 
                Attempts: 2
                EvaluateOnExit: 
                  - Action: "retry"
                    OnReason: "Host EC2*"
                    OnStatusReason: "onStatusReason"
                  - Action: "exit"
                    OnReason: "*"
                    OnStatusReason: "onReason"
            PlatformCapabilities:
              - FARGATE
            ContainerProperties: 
                FargatePlatformConfiguration:
                    PlatformVersion: LATEST
                ResourceRequirements:
                  - Value: 1
                    Type: VCPU
                  - Value: 2048
                    Type: MEMORY
                Command: 
                  - "python"
                  - "app.py"
                  - "Ref::s3videoName"
                  - "Ref::logLevel"
                  - "Ref::predThresh" 
                JobRoleArn: !GetAtt BatchPredictionJobRole.Arn
                Image: !Sub "${AWS::AccountId}.dkr.ecr.${AWS::Region}.amazonaws.com/${BatchPredictionECRRepoName}:latest"
                ExecutionRoleArn: !GetAtt BatchPredictionJobRole.Arn
        
    BatchJobQueue:
        DependsOn: DynamoDBTable
        Type: "AWS::Batch::JobQueue"
        Properties:
            ComputeEnvironmentOrder: 
              - Order: 1
                ComputeEnvironment: !Sub "arn:aws:batch:${AWS::Region}:${AWS::AccountId}:compute-environment/${BatchComputeEnvName}"
            Priority: 1
            State: "ENABLED"
            JobQueueName: !Sub "${BatchJobQueueName}" 

    DynamoDBTable:
        DependsOn: BatchComputeEnvironment
        Type: "AWS::DynamoDB::Table"
        Properties:
            AttributeDefinitions: 
              - AttributeName: "Long File Name"
                AttributeType: "S"
            TableName: !Sub "${DynamoDBTableName}"
            KeySchema: 
              - AttributeName: "Long File Name"
                KeyType: "HASH"
            ProvisionedThroughput: 
                ReadCapacityUnits: 1
                WriteCapacityUnits: 1

    ApplicationAutoScalingScalableTarget:
        DependsOn: DynamoDBTable
        Type: "AWS::ApplicationAutoScaling::ScalableTarget"
        Properties:
            MaxCapacity: 10
            MinCapacity: 1
            ResourceId: !Sub "table/${DynamoDBTable}"
            RoleARN: !Sub "arn:aws:iam::${AWS::AccountId}:role/aws-service-role/dynamodb.application-autoscaling.amazonaws.com/AWSServiceRoleForApplicationAutoScaling_DynamoDBTable"
            ScalableDimension: "dynamodb:table:ReadCapacityUnits"
            ServiceNamespace: "dynamodb"
            SuspendedState: 
                DynamicScalingInSuspended: false
                DynamicScalingOutSuspended: false
                ScheduledScalingSuspended: false

    BatchPredictionJobRole:
        Type: "AWS::IAM::Role"
        Properties:
            Path: "/"
            RoleName: "ECSVideoPredictionJobRole"
            AssumeRolePolicyDocument: "{\"Version\":\"2012-10-17\",\"Statement\":[{\"Sid\":\"\",\"Effect\":\"Allow\",\"Principal\":{\"Service\":\"ecs-tasks.amazonaws.com\"},\"Action\":\"sts:AssumeRole\"}]}"
            MaxSessionDuration: 3600
            ManagedPolicyArns: 
              - "arn:aws:iam::aws:policy/AmazonS3FullAccess"
              - "arn:aws:iam::aws:policy/AmazonDynamoDBFullAccess"
              - "arn:aws:iam::aws:policy/service-role/AmazonECSTaskExecutionRolePolicy"
            Description: "Allows ECS tasks to call AWS services on your behalf."

    TriggerBatchFunctionRole:
        Type: "AWS::IAM::Role"
        Properties:
            Path: "/service-role/"
            RoleName: "triggerBatch-role-nnkele43"
            AssumeRolePolicyDocument: "{\"Version\":\"2012-10-17\",\"Statement\":[{\"Effect\":\"Allow\",\"Principal\":{\"Service\":\"lambda.amazonaws.com\"},\"Action\":\"sts:AssumeRole\"}]}"
            MaxSessionDuration: 3600
            ManagedPolicyArns: 
              - "arn:aws:iam::aws:policy/service-role/AWSBatchServiceRole"
              - "arn:aws:iam::aws:policy/AWSBatchFullAccess"
              - !Ref LoggingIAMPolicy
    
    exportDynamoDBFunction:
        DependsOn: S3Bucket
        Type: "AWS::Lambda::Function"
        Properties:
            Description: "Exports the prediction_results_and_metadata dynamo table to s3 as a csv. Runs nightly"
            FunctionName: !Sub "${exportDynamoDBFunctionName}" 
            Handler: "lambda_function.lambda_handler"
            Architectures:
              - "x86_64"
            Code:
                ZipFile: !Sub |
                    import os, argparse, dropbox, time, requests
                    import json
                    import csv
                    import boto3
                    from boto3.dynamodb.conditions import Attr
                    from datetime import datetime
                    from pytz import timezone
                    from dropbox_utils import DropBoxUpload, get_token
                    import boto3, botocore
                    import os

                    # # Configure logging
                    # from logging_utils import get_logger_and_logFormatter, setup_log_stream_handler
                    # LOG, formatter = get_logger_and_logFormatter()
                    # setup_log_stream_handler(LOG, formatter)
                    # LOG.setLevel(20) # 20: info, 10: debug

                    def get_token():
                        params = {
                            "refresh_token": ${DropboxRefreshToken},
                            "grant_type": "refresh_token",
                            "client_id": ${DropboxAppKey},
                            "client_secret": ${DropboxAppSecret}
                        }
                        authorization = requests.post(refresh_url, data=params)
                        access_token = authorization.json()['access_token']

                        return access_token

                    class DropBoxUpload:
                        def __init__(self,token,timeout=900,chunk=8):
                            self.token = token
                            self.timeout = timeout
                            self.chunk = chunk

                        def UpLoadFile(self,upload_path,file_path):
                            dbx = dropbox.Dropbox(self.token,timeout=self.timeout)
                            file_size = os.path.getsize(file_path)
                            CHUNK_SIZE = self.chunk * 1024 * 1024
                            if '/tmp/' in file_path:
                                dest_file_path = file_path[4:]
                            dest_path = upload_path + '/' + os.path.basename(dest_file_path)
                            since = time.time()
                            with open(file_path, 'rb') as f:
                                uploaded_size = 0
                                if file_size <= CHUNK_SIZE:
                                    dbx.files_upload(f.read(), dest_path)
                                    time_elapsed = time.time() - since
                                    print('Uploaded {:.2f}%'.format(100).ljust(15) + ' --- {:.0f}m {:.0f}s'.format(time_elapsed//60,time_elapsed%60).rjust(15))
                                else:
                                    upload_session_start_result = dbx.files_upload_session_start(f.read(CHUNK_SIZE))
                                    cursor = dropbox.files.UploadSessionCursor(session_id=upload_session_start_result.session_id,
                                                                               offset=f.tell())
                                    commit = dropbox.files.CommitInfo(path=dest_path)
                                    while f.tell() <= file_size:
                                        if ((file_size - f.tell()) <= CHUNK_SIZE):
                                            dbx.files_upload_session_finish(f.read(CHUNK_SIZE), cursor, commit)
                                            time_elapsed = time.time() - since
                                            print('Uploaded {:.2f}%'.format(100).ljust(15) + ' --- {:.0f}m {:.0f}s'.format(time_elapsed//60,time_elapsed%60).rjust(15))
                                            break
                                        else:
                                            dbx.files_upload_session_append_v2(f.read(CHUNK_SIZE),cursor)
                                            cursor.offset = f.tell()
                                            uploaded_size += CHUNK_SIZE
                                            uploaded_percent = 100*uploaded_size/file_size
                                            time_elapsed = time.time() - since
                                            print('Uploaded {:.2f}%'.format(uploaded_percent).ljust(15) + ' --- {:.0f}m {:.0f}s'.format(time_elapsed//60,time_elapsed%60).rjust(15), end='\r')


                    # Here we state out target resource names
                    S3_BUCKET = ${BucketPrefix}
                    DYNAMODB_TABLE = ${DynamoDBTableName}
                    # LOG.debug({'s3bucket':S3_BUCKET, 'dynamodbTable':DYNAMODB_TABLE})


                    # Here we assign our aws resources to use
                    s3_resource = boto3.resource('s3')
                    dynamodb_resource = boto3.resource('dynamodb')

                    # Here we reference our target table
                    table = dynamodb_resource.Table(DYNAMODB_TABLE)


                    def export_table_to_csv():
                        # Here we get some timestamp attributes
                        timestamps = get_timestamps()

                        # Here we name our csv and append the date
                        fileNameFormat = f'prediction-results-and-metadata_{timestamps.get("date_format")}'
                        csvFileName = f'/tmp/{fileNameFormat}.csv'
                        print({'filename': csvFileName})

                        # Here we setup our dynamo table and its filter expressions
                        # camera_number is written to DynamoDB the moment the object is uploaded
                        # animals_detected is only writted one the processing job is completed
                        # Thus we only grab items in the table that have completed processing
                        print("Scanning table...")
                        response = table.scan(
                            FilterExpression=Attr("animals_detected").exists() & Attr("camera_number").exists() & Attr('export_date').not_exists()
                        )
                        # LOG.debug({"tableScan_res": response})

                        if response['Count'] != 0:
                            items = response['Items']
                            print(f'{len(items)} items found')
                            # Here we get the keys of the first object in items.
                            # We will use these keys for the headers/columns for our csv.
                            keys = items[0].keys()

                            for i, row in enumerate(items):
                                # write csv row
                                with open(csvFileName, 'a', encoding='utf8') as f:
                                    dict_writer = csv.DictWriter(f, keys)
                                    # Here we check to see if its the first write.
                                    if f.tell() == 0:
                                        dict_writer.writeheader()
                                        dict_writer.writerow(row)
                                    else:
                                        dict_writer.writerow(row)

                                # send video to dropbox
                                video_name = items[i]['Long File Name']
                                animals_detected = json.loads(items[i]['animals_detected'])
                                if len(animals_detected) == 0:
                                    animals_detected = ['ghost']
                                local_path = download_video_from_s3(video_name)
                                for animal in animals_detected:
                                    dropbox_path = f'/MIDS AI Data/{animal}'
                                    print(f'Sending {local_path} to {dropbox_path}')
                                    send_file_to_dropbox(dropbox_path,local_path)

                            # Send the csv to dropbox
                            local_path = csvFileName
                            dropbox_path = '/MIDS AI Data/Result CSV Files'
                            print(f"Sending {csvFileName} to DropBox in folder: {dropbox_path}")
                            send_file_to_dropbox(dropbox_path, local_path)

                            # Here we save a backup copy of the csv file in S3
                            print("Writing to s3...")
                            s3Object = s3_resource.Object(S3_BUCKET, f'dynamodb_exports/{csvFileName}')
                            s3Response = s3Object.put(Body=open(csvFileName, 'rb'))
                            print({"s3put_statusCode": s3Response['ResponseMetadata']['HTTPStatusCode']})
                            # LOG.debug({"s3put_res": s3Response})

                            if s3Response['ResponseMetadata']['HTTPStatusCode'] == 200:
                                # If the backup is saved succesfully add the exported date to the exported items in DynamoDB
                                print("Tagging exported items...")
                                response = tag_exported_items(table, items, timestamps.get("date_format"))
                                return {
                                    "status": True,
                                    "tag_status": response['ResponseMetadata']['HTTPStatusCode'],
                                    "file_name": str(csvFileName)
                                }
                            else:
                                return {
                                    "status": False
                            }

                        else:
                            return {
                                "status": False,
                                "message": "No new items found."
                            }


                    def get_timestamps():
                        eastern = timezone('US/Eastern')
                        eastern_date = datetime.now(eastern)
                        fmt = '%m-%d-%Y'
                        date_format = eastern_date.strftime(fmt)
                        time_format = eastern_date.strftime('%I:%M:%p')

                        return {
                            "date_format": str(date_format),
                            "time_format": str(time_format)
                        }


                    def tag_exported_items(table, items, tag):
                        for item in items:
                            response = table.update_item(
                                Key={'Long File Name':item['Long File Name']},
                                UpdateExpression='SET export_date = :export',
                                ExpressionAttributeValues={
                                    ':export': tag
                                }
                                )
                            # LOG.debug({"tagItem_res": response})

                        return response


                    def send_file_to_dropbox(dropbox_path, local_path):
                        token = get_token()
                        default_timeout = 900
                        default_chunks = 8

                        dbu = DropBoxUpload(token, timeout=default_timeout, chunk=default_chunks)
                        dbu.UpLoadFile(dropbox_path, local_path)


                    def send_video_to_dropbox(dropbox_path, url):
                        token = get_token()
                        default_timeout = 900

                        dbu = DropBoxUpload(token, timeout=default_timeout, chunk=None)
                        dbu.UploadURL(dropbox_path, url)

                    def download_video_from_s3(path, bucket=S3_BUCKET):
                        """Downloads mp4 locally from the s3 bucket"""
                        s3 = boto3.resource('s3')
                        if not os.path.exists('/tmp'):
                            os.makedirs('/tmp')
                        local_dir = "/tmp"

                        filename = path.split("/")[-1]
                        local_path = os.path.join(local_dir,filename)
                        try:
                            s3.Bucket(bucket).download_file(str(path), str(local_path))
                        except botocore.exceptions.ClientError as e:
                            if e.response['Error']['Code'] == "404":
                                print("The object does not exist.")
                            else:
                                raise

                        return local_path


                    def lambda_handler(event, context):
                        # TODO implement
                        response = export_table_to_csv()
                        return {
                            'statusCode': 200,
                            'body': json.dumps(response)
                        }
            MemorySize: 128
            Role: !GetAtt exportDynamoDBiamRole.Arn
            Runtime: "python3.8"
            Timeout: 360
            TracingConfig:
                Mode: "PassThrough"
            Layers:
              - !Sub "arn:aws:lambda:${AWS::Region}:770693421928:layer:Klayers-python38-pytz:6"
              - !Sub "arn:aws:lambda:${AWS::Region}:770693421928:layer:Klayers-p38-dropbox:1"

    getPresignedURLFunction:
        DependsOn: S3Bucket
        Type: "AWS::Lambda::Function"
        Properties:
            Description: !Sub "Fetches a signed post URL for uploading files to the \"${BucketPrefix}\" bucket"
            FunctionName: !Sub "${getPresignedURLFunctionName}" 
            Handler: "lambda_function.lambda_handler"
            Architectures:
              - "x86_64"
            Code:
                ZipFile: !Sub |
                    import json
                    import logging
                    import boto3
                    from botocore.exceptions import ClientError


                    def create_presigned_post(bucket_name: str, object_name: str,
                                              fields=None, conditions=None, expiration=3600):
                        """Generate a presigned URL S3 POST request to upload a file

                        :param bucket_name: string
                        :param object_name: string
                        :param fields: Dictionary of prefilled form fields
                        :param conditions: List of conditions to include in the policy
                        :param expiration: Time in seconds for the presigned URL to remain valid
                        :return: Dictionary with the following keys:
                            url: URL to post to
                            fields: Dictionary of form fields and values to submit with the POST
                        :return: None if error.
                        """

                        # Generate a presigned S3 POST URL
                        s3_client = boto3.client('s3')
                        try:
                            response = s3_client.generate_presigned_post(bucket_name,
                                                                         object_name,
                                                                         Fields=fields,
                                                                         Conditions=conditions,
                                                                         ExpiresIn=expiration)
                        except ClientError as e:
                            logging.error(e)
                            return None

                        # The response contains the presigned URL and required fields
                        return response

                    BUCKET = ${BucketPrefix}

                    def lambda_handler(event, context):
                        logging.warning(event)
                        # TODO implement
                        Object = event['queryStringParameters']['object']
                        put_permissions = create_presigned_post(BUCKET,Object)
                        return {
                            'statusCode': 200,
                            'body': json.dumps(put_permissions),
                            'event': event
                        }
            MemorySize: 128
            Role: !GetAtt getPresignedURLiamRole.Arn
            Runtime: "python3.9"
            Timeout: 3
            TracingConfig:
                Mode: "PassThrough"

    getPresignedURLapiGatewayLambdaPermission:
        DependsOn: ApiGatewayV2Api
        Type: "AWS::Lambda::Permission"
        Properties:
            Action: "lambda:InvokeFunction"
            FunctionName: !GetAtt getPresignedURLFunction.Arn
            Principal: "apigateway.amazonaws.com"
            SourceArn: !Sub "arn:aws:execute-api:${AWS::Region}:${AWS::AccountId}:${ApiGatewayV2Api}/*/*/${getPresignedURLFunctionName}"

    exportDynamoDBiamRole:
        DependsOn: LoggingIAMPolicy
        Type: "AWS::IAM::Role"
        Properties:
            Path: "/service-role/"
            RoleName: "exportDynamoDB-role-ycfv8hb1"
            AssumeRolePolicyDocument: "{\"Version\":\"2012-10-17\",\"Statement\":[{\"Effect\":\"Allow\",\"Principal\":{\"Service\":\"lambda.amazonaws.com\"},\"Action\":\"sts:AssumeRole\"}]}"
            MaxSessionDuration: 3600
            ManagedPolicyArns:
              - "arn:aws:iam::aws:policy/AmazonS3FullAccess"
              - "arn:aws:iam::aws:policy/AmazonDynamoDBFullAccess"
              - !Ref LoggingIAMPolicy

    getPresignedURLiamRole:
        DependsOn:
          - S3PutPolicy
          - LoggingIAMPolicy
        Type: "AWS::IAM::Role"
        Properties:
            Path: "/service-role/"
            RoleName: "getPresignedURL-role-q5wioknx"
            AssumeRolePolicyDocument: "{\"Version\":\"2012-10-17\",\"Statement\":[{\"Effect\":\"Allow\",\"Principal\":{\"Service\":\"lambda.amazonaws.com\"},\"Action\":\"sts:AssumeRole\"}]}"
            MaxSessionDuration: 3600
            ManagedPolicyArns:
              - !Ref S3PutPolicy
              - !Ref LoggingIAMPolicy

    ApiGatewayV2Api:
        DependsOn: getPresignedURLFunction
        Type: "AWS::ApiGatewayV2::Api"
        Properties:
            Name: "getPresignedURLApiGateway"
            ApiKeySelectionExpression: "$request.header.x-api-key"
            Description: "Created by AWS Lambda"
            ProtocolType: "HTTP"
            RouteSelectionExpression: "$request.method $request.path"
            CorsConfiguration:
                AllowOrigins:
                  - "*"
            DisableExecuteApiEndpoint: false

    ApiGatewayV2Stage:
        DependsOn: 
          - ApiGatewayV2Deployment
          - getPresignedURLLogGroup
        Type: "AWS::ApiGatewayV2::Stage"
        Properties:
            StageName: "default"
            StageVariables: {}
            ApiId: !Ref ApiGatewayV2Api
            RouteSettings: {}
            DefaultRouteSettings:
                DetailedMetricsEnabled: false
            AccessLogSettings:
                DestinationArn: !Sub "arn:aws:logs:${AWS::Region}:${AWS::AccountId}:log-group:/aws/lambda/${getPresignedURLFunctionName}"
                Format: "$context.identity.sourceIp - - [$context.requestTime] \"$context.httpMethod $context.routeKey $context.protocol\" $context.status $context.responseLength $context.requestId $context.integrationErrorMessage $context.error.message $context.error.responseType"
            AutoDeploy: true

    ApiGatewayV2Deployment:
        DependsOn: ApiGatewayV2Route
        Type: "AWS::ApiGatewayV2::Deployment"
        Properties:
            ApiId: !Ref ApiGatewayV2Api
            Description: "Automatic deployment triggered by changes to the Api configuration"

    ApiGatewayV2Route:
        DependsOn: ApiGatewayV2Integration
        Type: "AWS::ApiGatewayV2::Route"
        Properties:
            ApiId: !Ref ApiGatewayV2Api
            ApiKeyRequired: false
            AuthorizationType: "NONE"
            RouteKey: !Sub "ANY /${getPresignedURLFunction}"
            Target: !Sub "integrations/${ApiGatewayV2Integration}"
    
    ApiGatewayV2Integration:
        DependsOn: ApiGatewayV2Api
        Type: "AWS::ApiGatewayV2::Integration"
        Properties:
            ApiId: !Ref ApiGatewayV2Api
            ConnectionType: "INTERNET"
            IntegrationMethod: "POST"
            IntegrationType: "AWS_PROXY"
            IntegrationUri: !GetAtt getPresignedURLFunction.Arn
            TimeoutInMillis: 30000
            PayloadFormatVersion: "2.0"
    
    getPresignedURLLogGroup:
            Type: "AWS::Logs::LogGroup"
            Properties:
                LogGroupName: !Sub "/aws/lambda/${getPresignedURLFunctionName}"

    LoggingIAMPolicy:
        Type: "AWS::IAM::ManagedPolicy"
        Properties:
            ManagedPolicyName: "AWSLambdaBasicExecutionRole-eb27aca8-64d3-497b-bbb9-04f8e4d6ce58"
            Path: "/service-role/"
            PolicyDocument: !Sub |
                {
                    "Version": "2012-10-17",
                    "Statement": [
                        {
                            "Effect": "Allow",
                            "Action": "logs:CreateLogGroup",
                            "Resource": "arn:aws:logs:${AWS::Region}:${AWS::AccountId}:*"
                        },
                        {
                            "Effect": "Allow",
                            "Action": [
                                "logs:CreateLogStream",
                                "logs:PutLogEvents"
                            ],
                            "Resource": [
                                "arn:aws:logs:${AWS::Region}:${AWS::AccountId}:log-group:/aws/lambda/${exportDynamoDBFunctionName}:*", "arn:aws:logs:${AWS::Region}:${AWS::AccountId}:log-group:/aws/lambda/${getPresignedURLFunctionName}:*", "arn:aws:logs:${AWS::Region}:${AWS::AccountId}:log-group:/aws/lambda/${triggerBatchFunctionName}:*"
                            ]
                        }
                    ]
                }

    S3PutPolicy:
        DependsOn: S3Bucket
        Type: "AWS::IAM::ManagedPolicy"
        Properties:
            ManagedPolicyName: "saving-nature-put"
            Path: "/"
            PolicyDocument: !Sub |
                {
                    "Version": "2012-10-17",
                    "Statement": [
                        {
                            "Sid": "VisualEditor0",
                            "Effect": "Allow",
                            "Action": "s3:PutObject",
                            "Resource": "arn:aws:s3:::${BucketPrefix}/*"
                        }
                    ]
                }
    
    WebsiteECRRepository:
        Type: "AWS::ECR::Repository"
        Properties:
            RepositoryName: "web-application" 
        
    AppRunnerRole:
        Type: 'AWS::IAM::Role'
        Properties:
          AssumeRolePolicyDocument:
            Version: "2012-10-17"
            Statement:
              - Effect: Allow
                Principal:
                  Service:
                    - build.apprunner.amazonaws.com
                    - tasks.apprunner.amazonaws.com
                Action:
                  - 'sts:AssumeRole'
          Path: /
          Policies:
            - PolicyName: root
              PolicyDocument:
                Version: "2012-10-17"
                Statement:
                  - Effect: Allow
                    Action: 
                      - "ecr:GetDownloadUrlForLayer"
                      - "ecr:BatchGetImage"
                      - "ecr:DescribeImages"
                      - "ecr:GetAuthorizationToken"
                      - "ecr:BatchCheckLayerAvailability"
                    Resource: '*'
            - PolicyName: saving-natue-app-permissions
              PolicyDocument:
                Verison: "2012-10-17"
                Statement:
                  - Effect: Allow
                    Action:
                      - "dynamodb:UpdateItem"
                      - "logs:PutLogEvents"
                      - "logs:CreateLogStream"
                      - "logs:CreateLogGroup"
                    Resource:
                      - !Sub "arn:aws:logs:*:${AWS::AccountId}:log-group:*:log-stream:*"
                      - !Sub "arn:aws:dynamodb:*:${AWS::AccountId}:table/*"
                      - !Sub "arn:aws:logs:*:${AWS::AccountId}:log-group:*"
    
    AppRunner:
        Type: AWS::AppRunner::Service
        DependsOn: AppRunnerRole
        Properties:
          ServiceName: "Web Application Frontend"
          SourceConfiguration:
            AuthenticationConfiguration:
              AccessRoleArn: !GetAtt AppRunnerRole.Arn
            AutoDeploymentsEnabled: true
            ImageRepository:
              ImageRepositoryType: ECR
              ImageIdentifier: !Sub "${WebsiteECRRepository.RepositoryUri}:latest"
              ImageConfiguration:
                Port: 8080
           InstanceConfiguration:
             Cpu: 1024
             Memory: 2GB

Outputs:
  AppRunner:
    Description: URL of the deployed App Runner Service
    Value: !Join
            - ''
            - - "https://"
              - !GetAtt AppRunner.ServiceUrl
